#pragma once

class State_machine::Action
{
	private:
		State_machine::Env& _env;
		Genode::Xml_node const _config;

	protected:
		State_machine::Env& env() { return _env; }
		Genode::Xml_node const& config() { return _config; }

	public:
		virtual void perform() = 0;

		Action(State_machine::Env& env, Genode::Xml_node const& config)
		 : _env(env), _config(config)
		{
		}

		virtual ~Action()
		{
		}
};

class State_machine::Action_factory
{
	public:
		virtual State_machine::Action& create(State_machine::Env& env, Genode::Xml_node const& config) = 0;

		virtual ~Action_factory()
		{
		}
};

