#pragma once

class State_machine::Env
{
	private:
		Genode::Env& _env;
		Genode::Heap& _heap;
		bool _verbose;

	public:
		Genode::Env& env() { return _env; }
		Genode::Allocator& alloc() { return _heap; }
		bool verbose() { return _verbose; }

		virtual Condition& create_condition(Genode::Xml_node const& node) = 0;
		virtual Provider& create_provider(Genode::Xml_node const& node) = 0;
		virtual Action& create_action(Genode::Xml_node const& node) = 0;
		virtual Variable_value& get_variable(Variable_name& name) = 0;
		virtual void set_variable(Variable_name& name, Variable_value& value) = 0;
		virtual void register_variable_sigh(Variable_name& name, Genode::Signal_context_capability sigh) = 0;
		virtual void set_progressed() = 0;
		virtual void reset_progressed() = 0;
		virtual bool has_progressed() = 0;

		Env(Genode::Env& env, Genode::Heap& heap, bool verbose)
		 : _env(env), _heap(heap), _verbose(verbose)
		{
		}

		virtual ~Env()
		{
		}
};

