#pragma once

#include <base/env.h>
#include <base/heap.h>
#include <util/reconstructible.h>

namespace State_machine {
	constexpr unsigned Variable_value_capacity = 256u;

	typedef Genode::String<32> Node_name;
	typedef Genode::String<64> Library_name;
	typedef Genode::String<64> Variable_name;
	typedef Genode::String<Variable_value_capacity> Variable_value;

	class Env;
	class Condition;
	class Condition_factory;
	class Provider;
	class Standard_provider;
	class Buffered_provider;
	class Provider_factory;
	class Action;
	class Action_factory;

	class Buffer_overflow { };
	class Length_too_large { };
}

#include "env.h"
#include "condition.h"
#include "provider.h"
#include "action.h"

